%global eclipse_dropin   %{_datadir}/eclipse/dropins
%global git_version 95aacfe82466cb691f5adf09aae33c361335935b

Name:           eclipse-linuxtools
Version:        2.0.0
Release:        0.1.git95aacfe%{?dist}
Summary:        Linux specific Eclipse plugins

License:        EPL
URL:            http://eclipse.org/linuxtools/
Source0:        http://git.eclipse.org/c/linuxtools/org.eclipse.linuxtools.git/snapshot/org.eclipse.linuxtools-%{git_version}.tar.bz2
Patch0:         remove-parent.patch
Patch1:         disable-libhover-lttng.patch
Patch2:         disable-jacoco-maven-plugin.patch

BuildRequires: tycho
BuildRequires: tycho-extras  
BuildRequires: eclipse-cdt
BuildRequires: eclipse-jdt
BuildRequires: swt-chart
BuildRequires: maven-clean-plugin
BuildRequires: eclipse-swtbot
BuildRequires: eclipse-gef
BuildRequires: osgi(org.eclipse.ptp.remote.core)
BuildRequires: exec-maven-plugin

BuildArch: noarch
Obsoletes: eclipse-linuxprofilingframework < %{version}-%{release}
Provides: eclipse-linuxprofilingframework = %{version}-%{release}

%description
The Linux Tools project is a two-faceted project. Firstly, it develops tools 
and frameworks for writing tools for Linux developers. Secondly, it provides
a place for Linux distributions to collaboratively overcome issues surrounding 
distribution packaging of Eclipse technology. The project will produce both
best practices and tools related to packaging. 

%package -n eclipse-changelog

Version:        2.8.1
Summary:        Eclipse ChangeLog plug-in
Epoch:          2

%description -n eclipse-changelog
The Eclipse ChangeLog package contains Eclipse features and plugins that are
useful for ChangeLog maintenance within the Eclipse IDE.  It includes
fragments for parsing C, C++, and Java source files to create more detailed
entries containing function or method names.

%package -n eclipse-rpmstubby

Summary:        Rpm spec file generator

%description -n eclipse-rpmstubby
RPM Stubby Plug-in is a plugin aiming to auto-generate RPM spec files.

%package -n eclipse-rpm-editor

Summary:  RPM Spec file editor for Eclipse
Requires: rpmlint >= 0.81
Requires: rpmdevtools

%description -n eclipse-rpm-editor
The Eclipse Spec file Editor package contains Eclipse plugins that are
useful for maintenance of RPM spec files within the Eclipse IDE.

%package -n eclipse-manpage

Summary:  Man page viewer

%description -n eclipse-manpage
Plugin providing common interface for displaying a man page in a view or 
fetching its content for embedded display purposes (e.g hover help).

%package -n eclipse-gcov

Summary:  GCov Integration

%description -n eclipse-gcov
Functionality to integrate GCov with the Eclipse workbench.

%package -n eclipse-gprof

Summary:  GProf Integration

%description -n eclipse-gprof
Functionality to integrate GProf with the Eclipse workbench.

%package -n eclipse-oprofile

Summary:  Eclipse plugin for OProfile integration
Requires: oprofile >= 0.9.3
Requires: usermode >= 1.98

%description -n eclipse-oprofile
Eclipse plugins to integrate OProfile's profiling capabilities with the CDT.

%package -n eclipse-perf

Summary:  Eclipse plugin for Perf integration
Requires: perf

%description -n eclipse-perf
Eclipse plugins to integrate Perf's profiling capabilities with the CDT.

%package -n eclipse-valgrind

Summary:   Valgrind Tools Integration for Eclipse
Requires:  valgrind

%description -n eclipse-valgrind
This package for Eclipse allows users to launch their C/C++ Development Tools
projects using the Valgrind tool suite and presents the results in the IDE. 

%package -n eclipse-systemtap

Summary:   Systemtap Tools Integration for Eclipse
Requires:  systemtap
Obsoletes: eclipse-callgraph < %{version}-%{release}
Obsoletes: eclipse-systemtapgui < 1.2
Provides: eclipse-callgraph = %{version}-%{release}
Provides: eclipse-systemtapgui = 1.2

%description -n eclipse-systemtap
Integrate Systemtap's profiling and tracing capabilities with the CDT.


%prep
%setup -q -n org.eclipse.linuxtools-%{git_version}

%patch0
%patch1
%patch2

%pom_disable_module lttng
%pom_disable_module libhover

%build
mvn-rpmbuild clean install -Dmaven.test.skip=true -DskipTychoVersionCheck=true

pushd releng/org.eclipse.linuxtools.releng-site/target/repository/features
for f in `ls -1 . | grep jar$`; do
    unzip $f -d ${f/.jar//};
    rm -fr $f
done
popd

%install
install -d -m 755 %{buildroot}%{eclipse_dropin}

for s in changelog rpmstubby perf valgrind oprofile man rpm gcov gprof systemtap linuxtools; do
mkdir -p %{buildroot}%{eclipse_dropin}/$s/{plugins,features}
done

pushd releng/org.eclipse.linuxtools.releng-site/target/repository
#changelog
mv ./plugins/*changelog* %{buildroot}%{eclipse_dropin}/changelog/plugins
mv ./features/*changelog* %{buildroot}%{eclipse_dropin}/changelog/features
#rpmstubby
mv ./plugins/*rpmstubby* %{buildroot}%{eclipse_dropin}/rpmstubby/plugins
mv ./features/*rpmstubby* %{buildroot}%{eclipse_dropin}/rpmstubby/features

#rpm
mv ./plugins/*rpm* %{buildroot}%{eclipse_dropin}/rpm/plugins
mv ./features/*rpm* %{buildroot}%{eclipse_dropin}/rpm/features

#man
mv ./plugins/*man* %{buildroot}%{eclipse_dropin}/man/plugins
mv ./features/*man* %{buildroot}%{eclipse_dropin}/man/features

#gcov
mv ./plugins/*gcov* %{buildroot}%{eclipse_dropin}/gcov/plugins
mv ./features/*gcov* %{buildroot}%{eclipse_dropin}/gcov/features

#gprof
mv ./plugins/*gprof* %{buildroot}%{eclipse_dropin}/gprof/plugins
mv ./features/*gprof* %{buildroot}%{eclipse_dropin}/gprof/features

#perf
mv ./plugins/*perf* %{buildroot}%{eclipse_dropin}/perf/plugins
mv ./features/*perf* %{buildroot}%{eclipse_dropin}/perf/features

#valgrind
mv ./plugins/*valgrind* %{buildroot}%{eclipse_dropin}/valgrind/plugins
mv ./features/*valgrind* %{buildroot}%{eclipse_dropin}/valgrind/features

#oprofile
mv ./plugins/*oprofile* %{buildroot}%{eclipse_dropin}/oprofile/plugins
mv ./features/*oprofile* %{buildroot}%{eclipse_dropin}/oprofile/features

#systemtap
mv ./plugins/*systemtap* %{buildroot}%{eclipse_dropin}/systemtap/plugins
mv ./features/*systemtap* %{buildroot}%{eclipse_dropin}/systemtap/features
mv ./plugins/*callgraph* %{buildroot}%{eclipse_dropin}/systemtap/plugins
mv ./features/*callgraph* %{buildroot}%{eclipse_dropin}/systemtap/features

#linuxtools
mv ./plugins/* %{buildroot}%{eclipse_dropin}/linuxtools/plugins
mv ./features/* %{buildroot}%{eclipse_dropin}/linuxtools/features

popd

### oprofile install.sh stuff ###
pushd %{buildroot}%{eclipse_dropin}/oprofile/plugins
OPROFILECOREVERSION=$(ls . | grep org.eclipse.linuxtools.oprofile.core_ | sed 's/org.eclipse.linuxtools.oprofile.core_//' |sed 's/.jar//')
unzip org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION.jar -d ./org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION
rm -fr org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION.jar
%global corepath %{buildroot}%{eclipse_dropin}/oprofile/plugins/org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION

#create opcontrol wrapper
pushd %{corepath}/natives/linux/scripts
rm -f .svnignore
echo '#!/bin/sh' > opcontrol
echo 'exec pkexec /usr/bin/opcontrol ${1+"$@"}' >> opcontrol
popd

#install opcontrol wrapper permission files
install -d -m 755 %{buildroot}%{_datadir}/polkit-1/actions
install -D -m 644 \
 org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION/natives/linux/scripts/org.eclipse.linuxtools.oprofile.policy \
%{buildroot}%{_datadir}/polkit-1/actions/org.eclipse.linuxtools.oprofile.policy

#remove installed files
rm -f org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION/natives/linux/scripts/org.eclipse.linuxtools.oprofile.policy

popd


%files
%{eclipse_dropin}/linuxtools
%doc profiling/org.eclipse.linuxtools.profiling-feature/license.html
%doc profiling/org.eclipse.linuxtools.profiling-feature/epl-v10.html

%files -n eclipse-changelog
%{eclipse_dropin}/changelog
%doc changelog/org.eclipse.linuxtools.changelog-feature/license.html
%doc changelog/org.eclipse.linuxtools.changelog-feature/epl-v10.html

%files -n eclipse-rpmstubby
%{eclipse_dropin}/rpmstubby
%doc rpmstubby/org.eclipse.linuxtools.rpmstubby-feature/license.html
%doc rpmstubby/org.eclipse.linuxtools.rpmstubby-feature/epl-v10.html

%files -n eclipse-rpm-editor
%{eclipse_dropin}/rpm
%doc rpm/org.eclipse.linuxtools.rpm-feature/license.html
%doc rpm/org.eclipse.linuxtools.rpm-feature/epl-v10.html

%files -n eclipse-manpage
%{eclipse_dropin}/man
%doc man/org.eclipse.linuxtools.man-feature/license.html
%doc man/org.eclipse.linuxtools.man-feature/epl-v10.html

%files -n eclipse-gcov
%{eclipse_dropin}/gcov
%doc gcov/org.eclipse.linuxtools.gcov-feature/license.html
%doc gcov/org.eclipse.linuxtools.gcov-feature/epl-v10.html

%files -n eclipse-gprof
%{eclipse_dropin}/gprof
%doc gprof/org.eclipse.linuxtools.gprof-feature/license.html
%doc gprof/org.eclipse.linuxtools.gprof-feature/epl-v10.html

%files -n eclipse-oprofile
%{eclipse_dropin}/oprofile
%attr(755, root, root) %{eclipse_dropin}/oprofile/plugins/org.eclipse.linuxtools.oprofile.core_*/natives/linux/scripts/opcontrol
%{_datadir}/polkit-1/actions/org.eclipse.linuxtools.oprofile.policy
%doc oprofile/org.eclipse.linuxtools.oprofile-feature/license.html
%doc oprofile/org.eclipse.linuxtools.oprofile-feature/epl-v10.html

%files -n eclipse-perf
%{eclipse_dropin}/perf
%doc perf/org.eclipse.linuxtools.perf-feature/license.html
%doc perf/org.eclipse.linuxtools.perf-feature/epl-v10.html

%files -n eclipse-valgrind
%{eclipse_dropin}/valgrind
%doc valgrind/org.eclipse.linuxtools.valgrind-feature/license.html
%doc valgrind/org.eclipse.linuxtools.valgrind-feature/epl-v10.html

%files -n eclipse-systemtap
%{eclipse_dropin}/systemtap
%doc systemtap/org.eclipse.linuxtools.systemtap-feature/license.html
%doc systemtap/org.eclipse.linuxtools.systemtap-feature/epl-v10.html

%changelog
* Wed Mar 27 2013 Alexander Kurtakov <akurtako@redhat.com> 2.0.0-0.1.git95aacfe
- Update to 2.0.0 prerelease for Kepler compatibility.
- Changelog no longer has it's own release as the version bumped.

* Mon Feb 4 2013 <swagiaal@redhat.com> 1.2.0-5
- Actually remove 'Requires: kernel-debuginfo' from systemtap.

* Wed Jan 30 2013 <swagiaal@redhat.com> 1.2.0-4
- Remove 'Requires: kernel-debuginfo' from systemtap.

* Thu Jan 24 2013 <rgrunber@redhat.com> 1.2.0-3
- Properly package PolicyKit for Eclipse OProfile.

* Mon Jan 7 2013 <swagiaal@redhat.com> 1.2.0-2
- Add 'Requires' to systemtap on kernel-debuginfo.

* Fri Nov 23 2012 Roland Grunberg <rgrunber@redhat.com> 1.2.0-1
- Update to 1.2.0 upstream release.
- Disable jacoco-maven-plugin.

* Fri Oct 5 2012 Roland Grunberg <rgrunber@redhat.com> 1.1.1-3
- Synchronize release number for subpackages and rebuild.

* Fri Oct 5 2012 Roland Grunberg <rgrunber@redhat.com> 1.1.1-2
- Bump release to avoid conflicting with previous build.

* Tue Oct 2 2012 Roland Grunberg <rgrunber@redhat.com> 1.1.1-1
- Update to 1.1.1 upstream release.

* Wed Aug 8 2012 Alexander Kurtakov <akurtako@redhat.com> 1.1.0-1
- Initial packaging.
